SystemOrganization addCategory: #'FileMan-Adaptor-FileSystem'!

!FileSystemDirectoryEntry methodsFor: '*FileMan-Adaptor-FileSystem' stamp: 'MasashiUmezawa 3/24/2013 23:04'!
fileSize
	^self size! !

!FileSystemDirectoryEntry methodsFor: '*FileMan-Adaptor-FileSystem' stamp: 'MasashiUmezawa 3/24/2013 23:59'!
name
	^self basename! !

FmFileIOAccessor subclass: #FmFileSystemFileIOAccessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FileMan-Adaptor-FileSystem'!

!FmFileSystemFileIOAccessor methodsFor: 'private' stamp: 'MasashiUmezawa 3/28/2013 00:56'!
bareEntriesIn: fullPath
	^[fullPath asFileReference entries] on: DirectoryDoesNotExist do: [:ex | #()]! !

!FmFileSystemFileIOAccessor methodsFor: 'private' stamp: 'MasashiUmezawa 3/24/2013 23:46'!
basicDirectoryExists: fullPathName
	| ref |
	ref := fullPathName asFileReference.
	^ref exists and: [ref isDirectory]! !

!FmFileSystemFileIOAccessor methodsFor: 'actions' stamp: 'MasashiUmezawa 8/28/2015 19:48'!
createDirectory: fullPathName
	^ FileSystem disk createDirectory: fullPathName! !

!FmFileSystemFileIOAccessor methodsFor: 'accessing' stamp: 'MasashiUmezawa 3/24/2013 22:17'!
defaultDirectoryPath
	^ FileSystem disk workingDirectory path printWithDelimiter: self pathNameDelimiter! !

!FmFileSystemFileIOAccessor methodsFor: 'actions' stamp: 'MasashiUmezawa 3/28/2013 01:22'!
deleteDirectory: fullPathName
	^[fullPathName asFileReference delete] on: Error do: [ :ex | 
		fullPathName asFileReference delete] "one retry"! !

!FmFileSystemFileIOAccessor methodsFor: 'utilities' stamp: 'MasashiUmezawa 3/24/2013 22:48'!
directoryNamesIn: fullPath
	^ fullPath asFileReference directoryNames ! !

!FmFileSystemFileIOAccessor methodsFor: 'accessing' stamp: 'MasashiUmezawa 3/24/2013 22:06'!
drives
	| letters |
	letters := 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' select: [ :each |
		(FileLocator perform: (each asSymbol)) exists
 	].
	^letters asArray collect: [ :each | String with: each with: $: ]! !

!FmFileSystemFileIOAccessor methodsFor: 'utilities' stamp: 'MasashiUmezawa 3/24/2013 23:10'!
entryNamesIn: fullPath
	| ents |
	ents := [(fullPath asFileReference entries)] on: DirectoryDoesNotExist do: [:ex | ex return: #()].
	^ents collect: [:each | each basename ]! !
